// MediaViewer.h: CMediaViewer NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#pragma once

#include <Bdaiface.h>

#include "MediaDecoder.h"
#include "TsUtilClass.h"
#include "..\DirectShowFilter\BonSrcFilter.h"
#include "..\DirectShowFilter\AacDecFilter.h"
#include "..\DirectShowFilter\Mpeg2SequenceFilter.h"
#include "..\DirectShowFilter\PcmSelectFilter.h"
#include "..\DirectShowFilter\EnumFilter.h"


/////////////////////////////////////////////////////////////////////////////
// fBAr[A(fyщĐ)
/////////////////////////////////////////////////////////////////////////////
// Input	#0	: CTsPacket		̓f[^
/////////////////////////////////////////////////////////////////////////////

class CMediaViewer : public CMediaDecoder  
{
public:
	CMediaViewer(IEventHandler *pEventHandler = NULL);
	virtual ~CMediaViewer();

// IMediaDecoder
	virtual void Reset(void);

	virtual const bool InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex = 0UL);

// CMediaViewer
	const bool OpenViewer(HWND hOwnerHwnd = NULL,HWND hMessageDrainHwnd = NULL);
	void CloseViewer(void);

	const bool Play(void);
	const bool Stop(void);
	
	const bool SetVideoPID(const WORD wPID);
	const bool SetAudioPID(const WORD wPID);

	// Append by Meru
	const bool ResizeVideoWindow();
	const bool SetViewSize(const int x,const int y);
	const bool SwitchFullscreen();
	const bool SetVolume(const long lVolume);
	const bool GetVideoSize(WORD *pwWidth,WORD *pwHeight);
	const bool GetVideoAspectRatio(BYTE *pbyAspectRatioX,BYTE *pbyAspectRatioY);
	const BYTE GetAudioChannelNum();
	const bool SetStereoMode(const int iMode);
	const bool GetVideoDecorderName(LPWSTR lpName,int iBufLen);
	const bool DisplayVideoDecorderProperty(HWND hWndParent);
	const bool DisplayVideoRanderProperty(HWND hWndParent);
	
	// Append
	BOOL GetSnapShot_BasicVideo(long *pBufferSize, long *pDIBImage);

protected:
	CCriticalLock m_CriticalLock;

	// DirectShowC^tF[X
	BOOL m_bPlay;
	bool m_bInit;
	IMediaControl *m_pMediaControl;
	
	// DirectShowtB^
	IGraphBuilder *m_pFilterGraph;
	
	CBonSrcFilter *m_pBonSrcFilter;
	CAacDecFilter *m_pAacDecFilter;
	CMpeg2SequenceFilter *m_pMpeg2SeqFilter;
	CPcmSelectFilter *m_pPcmSelFilter;

	IBaseFilter *m_pBonSrcFilterIF;
	IBaseFilter *m_pAacDecFilterIF;
	IBaseFilter *m_pMpeg2SeqFilterIF;
	IBaseFilter *m_pPcmSelFilterIF;
	
	IBaseFilter *m_pMp2DemuxFilter;
	IBaseFilter *m_pMpeg2DecFilter;

	char m_szMpeg2DecorderName[120];

	// MPEG2DemultiplexerC^tF[X
	IMpeg2Demultiplexer *m_pMp2DemuxInterface;
	IReferenceClock *m_pMp2DemuxRefClock;

	// rfIPID}bv
	IMPEG2PIDMap *m_pMp2DemuxVideoMap;
	IMPEG2PIDMap *m_pMp2DemuxAudioMap;

	// rfIEBhE
	IVideoWindow *m_pVideoWindow;

	// rfI
	IBasicVideo2 *m_pBasicVideo;

	// I[fBI
	IBasicAudio *m_pBasicAudio;
	
	// Elementary StreamPID
	WORD m_wVideoEsPID;
	WORD m_wAudioEsPID;

	static void CALLBACK OnMpeg2VideoInfo(const Mpeg2VideoInfo *pVideoInfo,const LPVOID pParam);
	WORD m_wVideoWindowX;
	WORD m_wVideoWindowY;
	Mpeg2VideoInfo m_VideoInfo;
	HWND m_hOwnerWnd;
	bool m_bFullscreen;
	
private:
	HRESULT AddToRot(IUnknown *pUnkGraph, DWORD *pdwRegister) const;
	void RemoveFromRot(const DWORD pdwRegister) const;

	DWORD m_dwRegister;
};
